/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

// Global variables.

var intUpdateTimer = 0;
var intCalcTimer = 0;
var intCalcText = 0;

var intCreditTimer = 0;
var intCreditStartPos = 40;
var intCreditEndPos = -75;
var intCreditSeek = 40;
var strCreditUnit = "px";

var VanaDay = new Array("Firesday", "Earthsday", "Watersday", "Windsday", "Iceday", "Lightningday", "Lightsday", "Darksday");
var PhaseName = new Array("Full Moon","Waning Gibbous","Last Quarter","Waning Crescent","New Moon","Waxing Crescent","First Quarter","Waxing Gibbous");
//var DayColour = new Array("#DD0000", "#AAAA00", "#0000DD", "#00AA22", "#7799FF", "#AA00AA", "#AAAAAA", "#333333"); 

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    dashcode.setupParts();
    intUpdateTimer = setInterval(updatetime, 500);
    intCalcTimer = setInterval(calcalter, 30000);
    
    // Setup the HTML for the credits.
    
    document.getElementById("credits").innerHTML = '<font size="4">Vana\'diel Clock</font><br>Version 1.0<br><br> \
    <font size="2">Created by Steve Brokenshire &lt;kirinji@kyou.co.uk&gt;<br><br>Vana\'diel Time, Moon Phases and \
    Day Colour codes from Pyogenes\'s Final Fantasy XI timer at http://www.pyogenes.com/<br><br> \
    This widget was not developed by Square-Enix Co. of Japan. Final Fantasy XI is a registered trademark of \
    Square-Enix Co. of Japan. Please use this widget at your own risk.<br><br> \
    Thank you for using this widget!</font>';
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage.
    clearInterval(intUpdateTimer);
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    intUpdateTimer = setInterval(updatetime, 500);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}



//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

//
// Function: showAbout(event)
// Called when the about button is clicked to show the about subview.
//
// event: onClick event from the about button.
//
function showAbout(event)
{
    var back = document.getElementById("back");
    var about = document.getElementById("about");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    back.style.display = "none";
    about.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
    
    // Start scrolling (or continue) scrolling the credits.
    
    scrollCredits();
}

//
// Function: showBackfromAbout(event)
// Called when the done button is clicked on in the about subview.
//
// event: onClick event from the done button in the about subview.
//
function showBackfromAbout(event)
{

    // Stop scrolling the credits.

    clearInterval(intCreditTimer);

    var back = document.getElementById("about");
    var about = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    back.style.display = "none";
    about.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: updatetime(event)
// Arguably the most important subroutine in this Dashboard widget as it
// updates most of the parts on the front subview.
//
// event: Called when 500ms passes on the intUpdateTimer
//
function updatetime(event){
    
    // Using the Calculations code from Pyogenes - http://www.pyogenes.com
    // This code is the version 3 code of the FFXI timer.

    basisDate = new Date();
    basisDate.setUTCFullYear(2002, 5, 23);
    basisDate.setUTCHours(15, 0, 0, 0);

    msGameDay	= (24 * 60 * 60 * 1000 / 25); // milliseconds in a game day
    msRealDay	= (24 * 60 * 60 * 1000); // milliseconds in a real day

   var now = new Date();
   vanaDate =  ((898 * 360 + 30) * msRealDay) + (now.getTime() - basisDate.getTime()) * 25;

   vYear = Math.floor(vanaDate / (360 * msRealDay));
   vMon  = Math.floor((vanaDate % (360 * msRealDay)) / (30 * msRealDay)) + 1;
   vDate = Math.floor((vanaDate % (30 * msRealDay)) / (msRealDay)) + 1;
   vHour = Math.floor((vanaDate % (msRealDay)) / (60 * 60 * 1000));
   vMin  = Math.floor((vanaDate % (60 * 60 * 1000)) / (60 * 1000));
   vSec  = Math.floor((vanaDate % (60 * 1000)) / 1000);
   vDay  = Math.floor((vanaDate % (8 * msRealDay)) / (msRealDay));

   if (vYear < 1000) { vanaYear = "0" + vYear; } else { vanaYear = vYear; }
   if (vMon  < 10)   { vanaMonth  = "0" + vMon; }  else { vanaMonth  = vMon; }
   if (vDate < 10)   { vanaDate = "0" + vDate; } else { vanaDate = vDate; }
   if (vHour < 10)   { vanaHour = "0" + vHour; } else { vanaHour = vHour; }
   if (vMin  < 10)   { vanaMin  = "0" + vMin; }  else { vanaMin  = vMin; }
   if (vSec  < 10)   { vanaSec  = "0" + vSec; }  else { vanaSec  = vSec; }

    // Moon Phase Calculations.

    // moon date is used to determien the current hase of the moon.
    // Use UTC functions to allow calculations to work for any timezone
    Mndate = new Date();
    Mndate.setUTCFullYear(2004, 0, 25); // Set date to 2004-01-25
    Mndate.setUTCHours(2, 31, 12, 0);    // Set time to 02:31:12.0000

   var timenow = new Date();
   var localTime = timenow.getTime();
   var moonDays = (Math.floor((localTime - Mndate.getTime()) / msGameDay))  % 84;

   var mnElapsedTime = (localTime - Mndate.getTime()) % msGameDay;

   // determine phase percentage
         moonpercent = - Math.round((42 - moonDays) / 42 * 100);
         if (moonpercent <= -94)  {
            mnPhase = 0;
            optPhase = 4;
            toNextPhase = (3 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (38 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= 90)  {
	    mnPhase = 0;
            optPhase = 4;
            toNextPhase = (87 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (38 + 84 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= -93 && moonpercent <= -62)  {
	      mnPhase = 1;
            optPhase = 4;
            toNextPhase = (17 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (38 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= -61 && moonpercent <= -41)  {
	      mnPhase = 2;
            optPhase = 4;
            toNextPhase = (25 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (38 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= -40 && moonpercent <= -11)  {
	      mnPhase = 3;
            optPhase = 4;
            toNextPhase = (38 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (38 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= -10 && moonpercent <= 6)  {
	      mnPhase = 4;
            optPhase = 0;
            toNextPhase = (45 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (80 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= 7 && moonpercent <= 36)  {
	      mnPhase = 5;
            optPhase = 0;
            toNextPhase = (58 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (80 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= 37 && moonpercent <= 56)  {
	      mnPhase = 6;
            optPhase = 0;
            toNextPhase = (66 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (80 - moonDays) * msGameDay - mnElapsedTime;

         }  else if (moonpercent >= 57 && moonpercent <= 89)  {
	      mnPhase = 7;
            optPhase = 0;
            toNextPhase = (60 - moonDays) * msGameDay - mnElapsedTime;
            toOptimalPhase = (80 - moonDays) * msGameDay - mnElapsedTime;
         }
         
    // Process the information from the Calculations by Pyogenes and present it
    // into a readable fashion (and change the moon colour as needed).
    
    document.getElementById('vanatime').innerHTML = vanaHour + ':' + vanaMin;
    document.getElementById('vanadate').innerHTML = vanaDate + '/' + vanaMonth + '/' + vanaYear;
    document.getElementById('vanaday').innerHTML = VanaDay[vDay];
    document.getElementById('moonstatus').innerHTML = PhaseName[mnPhase];
    document.getElementById('moonpercent').innerHTML = Math.abs(moonpercent) + "%";
    
    if (vDay == 0) { document.getElementById('moonfiresday').style.visibility = 'visible'; } else { document.getElementById('moonfiresday').style.visibility = 'hidden'; }
    if (vDay == 1) { document.getElementById('moonearthsday').style.visibility = 'visible'; } else { document.getElementById('moonearthsday').style.visibility = 'hidden'; }
    if (vDay == 2) { document.getElementById('moonwatersday').style.visibility = 'visible'; } else { document.getElementById('moonwatersday').style.visibility = 'hidden'; }
    if (vDay == 3) { document.getElementById('moonwindsday').style.visibility = 'visible'; } else { document.getElementById('moonwindsday').style.visibility = 'hidden'; }
    if (vDay == 4) { document.getElementById('mooniceday').style.visibility = 'visible'; } else { document.getElementById('mooniceday').style.visibility = 'hidden'; }
    if (vDay == 5) { document.getElementById('moonlightningday').style.visibility = 'visible'; } else { document.getElementById('moonlightningday').style.visibility = 'hidden'; }
    if (vDay == 6) { document.getElementById('moonlightsday').style.visibility = 'visible'; } else { document.getElementById('moonlightsday').style.visibility = 'hidden'; } 
    if (vDay == 7) { document.getElementById('moondarksday').style.visibility = 'visible'; } else { document.getElementById('moondarksday').style.visibility = 'hidden'; }
    
    document.getElementById('moonfront').style.visibility = 'hidden';
    
}

//
// Function: calcalter(event)
// Credits for the Calculations by Pyogenes. Alternates between
// "Calculations by Pyogenes" and "http://www.pyogenes.com".
//
// event: Called every 30 seconds via the intCalcTimer timer.
//
function calcalter(event){
    if (intCalcText == 0){
        document.getElementById('pyogenes').innerHTML = "http://www.pyogenes.com/";
        intCalcText = 1;
    } else {
        document.getElementById('pyogenes').innerHTML = "Calculations by Pyogenes"; 
        intCalcText = 0;
    }
}

//
// Function: calcLink(event)
// Called when the about button is clicked to show the about subview.
//
// event: onClick event from the about button.
//
function calcLink(event)
{
    var websiteURL = "http://www.pyogenes.com/";
    widget.openURL(websiteURL);
}

//
// Function: scrollCredits(event)
// Starts scrolling the credits.
//
// event: From clicking on the about button in the back subview.
//
function scrollCredits(event)
{
    intCreditTimer = setInterval(IncrementCredit, 75); 
}

//
// Function: IncrementCredit(event)
// Increments the scrolling credits.
//
// event: From the intCreditTimer every 75ms.
//
function IncrementCredit(event){
    intCreditSeek = intCreditSeek - 1;
    
    document.getElementById("credits").style.top = intCreditSeek + strCreditUnit;
}

//
// Function: ResetCredits(event)
// Called when the scrollarea in the about subview is clicked and resets the
// scrolling credits.
//
// event: onClick event from the scrollarea.
//
function ResetCredits(event)
{
    clearInterval(intCreditTimer);

    intCreditSeek = intCreditStartPos;
    document.getElementById("credits").style.top = intCreditStartPos + strCreditUnit;
    
    intCreditTimer = setInterval(IncrementCredit, 75);
}
